function [cepsout] = liftercc(cepsin,lifterl)
%[cepsout] = liftercc(cepsin,lifterl)
%
%LIFTERCC - lifter cepstral coefficients
%
% uses a raised sine window for liftering
%
% if lifterl is positive, then coefficients are liftered
% if lifterl is negative, then coefficients are UNliftered
% if lifterl is zero then nothing is done

[numceps,frames] = size(cepsin);


liftvect = (1 + (lifterl/2)*sin((pi/lifterl)*(1:numceps)) );

if(lifterl==0 | lifterl~=round(lifterl))
  cepsout = cepsin;
elseif(lifterl>0)
  cepsout = cepsin .* (liftvect'*ones(1,frames));
else
  % (lifterl<0)
  cepsout = cepsin ./ (liftvect'*ones(1,frames));
end

