function [sig_frm,outputv]=stft3d(sig,winlength,wintype,ndft)
%winlength=400;wintype=2;ndft=5;
ht=findobj(gcbf,'Tag','ndftmenu');
ndft=get(ht,'Value');
para=get(gcbf,'UserData')
fs=16000;
winovl=para(6);
   if winovl>=winlength,
      winovl=floor(winlength/3);
      ht=findobj(gcbf,'Tag','EditText3');
      set(ht,'String',num2str(winovl));
   end
sig_frm=sig2frames(sig,winlength,winlength-winovl)';
[frame_len,frame_no]=size(sig_frm)
%--------------win
if wintype==2
   sig_frm = sig_frm.*(hamming(frame_len)*ones(1,frame_no));
elseif wintype==3
   sig_frm = sig_frm.*(hanning(frame_len)*ones(1,frame_no));
end

%--------------
ndftn=32*(2^(ndft-1));
figure ;
%mesh(sig_frm);pause
%--------------------------
mtype=para(1)
switch mtype;
case 1
   sig_spec=abs(fft(sig_frm,ndftn));
   sig_spec=sig_spec(1:end/2,:);
   mesh(sig_spec);
   %mydata=sig_spec;
    set(gca,'UserData',sig_spec);
   view(140,40);
   xlabel('Time: (number of frame)')
   ylabel('Frequency: (index of DFT)')
   zlabel('amplitude in DB')
   title('the 3D STFT');
case 2
   close(gcf);return;
case 3
   [A,G]=lpc(sig_frm,para(2));
   A=A';
   for i=1:size(A,2)
      [h(:,i),w]=freqz(G(i),A(:,i),512);
   end
   
h=abs(h);
 h=20*log10(h);
 mesh(h);
 set(gca,'UserData',h);
   view(140,40);
   xlabel('Time: (number of frame)')
   ylabel('Frequency: (index of DFT)')
   zlabel('amplitude in DB')
   title('the 3D LPC Spectral');
   
case 4
   [A,G]=lpc(sig_frm,para(2));
   A=A';
   len=size(A,2);
   for i=1:len
   cep(:,i)=lpctocep(A(2:end,i),G(i));
cep(:,i)=liftercc(cep(:,i),para(5));
end
mesh(cep);

   view(140,40);
   xlabel('Time: (number of frame)')
   ylabel('LPC Cepstrum order')
   zlabel('amplitude')
   title('the 3D LPC-CEP');
   
case 5
   [mfc,logfb,fb]=mfcc(sig,fs,winlength,winlength-winovl,para(3),para(5),para(4),0,0);
    mesh(logfb);
 set(gca,'UserData',logfb);
    view(140,40);
   xlabel('Time: (number of frame)')
   ylabel('Mel filter index')
   zlabel('amplitude in DB')
   title('the 3D Mel filter output');
case 6
   [mfc,logfb,fb]=mfcc(sig,fs,winlength,winlength-winovl,para(3),para(5),para(4),0,0);
   mesh(mfc);
   view(140,40);
   xlabel('Time: (number of frame)')
   ylabel('MFCC order')
   zlabel('amplitude')
   title('the 3D MFCC');
case 7   
   if ndftn<winlength
      ndft=ceil(log2(winlength/32)+1);
      hh=findobj(gcbf,'Tag','ndftmenu');
      set(hh,'Value',ndft);
      ndftn=32*(2^(ndft-1));
      warn1(2);

   end
   for i=1:frame_no
      f(:,i)=psd(sig_frm(:,i),ndftn,fs);
  
   end
        
    f=20*log10(f);

    mesh(f);
     set(gca,'UserData',f);

   view(140,40);
   xlabel('Time: (number of frame)')
   ylabel('Frequency: (index of DFT)')
   zlabel('amplitude in DB')
   title('the 3D Power Spectrum Density');
end

if mtype==1 | mtype == 3|mtype==5|mtype==7
   a=gcf;
   b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','stft3dpt', ...
	'FontSize',0.299742, ...
	'Position',[0.9 .02 0.09 0.07], ...
	'String','Perfect !', ...
   'Tag','perfect');
elseif mtype==4 |mtype==6
a=gcf;
   b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','close(gcf);', ...
	'FontSize',0.299742, ...
	'Position',[0.9 .02 0.09 0.07], ...
	'String','Close it', ...
   'Tag','perfect');

end
set(gcf,'Name','3D Presentation, Use mouse, drag to rotate');
set(gcf,'UserData',[140 40 0 0]);
set(gcf,'WindowButtonDownFcn','rott start');
outputv=get(gca,'UserData');